﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.07
@EndOfDesignText@
'Static code module
Sub Class_Globals	
	Public vuetify As VuetifyApp
	Public home As VueComponent
	Public path As String
	Public name As String = "home"
	Private banano As BANano			'ignore
	Private chpAge As VField
	Private dlgPeople As VMsgBox
	Private dsPeople As BananoDataSource
	Private dtPeople As VueTable
	Private frmPeople As VForm
	Private txtfullname As VField
	Private txtid As VField
	Private txtlastname As VField
	Private txtname As VField
	Private VCol1 As VCol
	Private VContainer1 As VContainer
	Private VRow1 As VRow
End Sub

Sub Initialize(v As VuetifyApp)						'ignoreDeadCode
	'establish a reference to the app
	vuetify = v
	'initialize the component
	home.Initialize(Me, name)
	home.vuetify = vuetify
	'make this the start page
	home.StartPage
	path = home.path
	'
	'build the page html here
	banano.LoadLayout(home.Here, "home")
	'
	frmPeople.AddRule("firstname", "firstnamecheck")
	frmPeople.AddRule("lastname", "lastnamecheck")
	frmPeople.AddRule("lastname", "lastnamesizecheck")
		
	frmPeople.BindState(home)
	frmPeople.BindDataSource(dsPeople)
	frmPeople.BindDataTable(dtPeople)
	
	home.SetMounted(Me, "loadrecords", Null)
	'add this route component to the app
	vuetify.AddRoute(home)
End Sub	

Sub firstnamecheck(v As String) As Object	'ignoredeadcode
	v = BANanoShared.ValidString(v)
	If v = "" Then
		Return "This first name is required!"
	Else
		Return True
	End If
End Sub

Sub lastnamecheck(v As String) As Object	'ignoredeadcode
	v = BANanoShared.ValidString(v)
	If v = "" Then
		Return "This last name is required!"
	Else
		Return True
	End If
End Sub

Sub lastnamesizecheck(v As String) As Object	'ignoredeadcode
	v = BANanoShared.ValidString(v)
	Dim lnl As Int = v.Length
	If lnl <= 3 Then
		Return "This last name length cannot be less than 3 characters!"
	Else
		Return True
	End If
End Sub


Sub loadrecords
	
End Sub


Private Sub chpAge_Plus (e As BANanoEvent)
	chpAge.IncrementChip(home)
End Sub

Private Sub chpAge_Minus (e As BANanoEvent)
	chpAge.DecrementChip(home)
End Sub

Private Sub dtPeople_Add_Click (e As BANanoEvent)
	dsPeople.ADD
	'change the title of the dialog
	dlgPeople.Title = $"Add ${(dsPeople.Singular)}"$
	'change the ok label
	dlgPeople.OkLabel = "Save"
	'change the cancel label
	dlgPeople.CancelLabel = "Cancel"
	'show the dialog
	dlgPeople.Show
End Sub


Private Sub dlgPeople_Ok_Click (e As BANanoEvent)
	frmPeople.JoinFields(home, "fullname", " ", Array("firstname", "lastname"))
	'perform datasource verification
    dsPeople.VERIFY
    'peform the form validation
	home.refs = vuetify.GetRefs
	Dim bValid As Boolean = frmPeople.Validate(home)
	If bValid = False Then
		'the validation has failed
		vuetify.ShowSwalToastError("Please enter all required information!", 2000)
		Return
	End If
	'get the entered content on the form
	Dim person As Map = frmPeople.GetData(home)
	Log(person)
	person.Put("age", 48)
	frmPeople.SetData(home, person)
	
	'show a loading indicator on the ok button
	'dlgPeople.OkLoading = True
	'get the record from form (recordsource) and CREATE / UPDATE record depending on mode
	'dsPeople.CREATE_OR_UPDATE
End Sub


Private Sub dsPeople_Create (Success As Boolean, Response As String, Error As String, affectedRows As Int, Result As List)
'turn off the ok loading indicator
dlgPeople.OkLoading = False
	If Success And Response = dsPeople.RESULT_SUCCESS Then
	'hide the dialog
    dlgPeople.hide
	'run any method to load the records
	home.RunMethod("loadrecords", Null)
Else
	 Log(Error)
    vuetify.ShowSwalError("The operation could not be executed, please try again!")
	 Return
End If
End Sub

Private Sub dsPeople_Update (Success As Boolean, Response As String, Error As String, affectedRows As Int, Result As List)
'turn off the loading indicator
dlgPeople.OkLoading = False
	If Success And Response = dsPeople.RESULT_SUCCESS Then
	'hide the dialog
    dlgPeople.hide
	'run the method to load records
	home.RunMethod("loadrecords", Null)
Else
	 Log(Error)
    vuetify.ShowSwalError("The operation could not be executed, please try again!")
	 Return
End If
End Sub

Private Sub dlgpeople_Cancel_click (e As BANanoEvent)
	'hide the dialog
	dlgPeople.hide
End Sub

Private Sub dtPeople_Change (item As Map)
	
End Sub

Private Sub dtPeople_ClearSort_Click (e As BANanoEvent)
	
End Sub

Private Sub dtPeople_ColumnName_Minus (item As Map)
	
End Sub

Private Sub dtPeople_ColumnName_Plus (item As Map)
	
End Sub

Private Sub dtPeople_Delete (item As Map)
	
End Sub

Private Sub dtPeople_Edit (item As Map)
	
End Sub

Private Sub dtPeople_Refresh_Click (e As BANanoEvent)
	
End Sub