﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public vuetify As VuetifyApp		'ignore
	Public BANano As BANano		'ignore
	
	'PAGES
	Dim pgViewHome As ViewHome
	'
	Private appbar As VAppBar					'ignore
	Private appbartitle As VToolBarTitle		'ignore	
	Private appdrawer As VNavigationDrawer		'ignore
	Private apphamburger As VAppBarNavIcon		'ignore
	Private applogo As VImg						'ignore
	Private appmain As VMain					'ignore
	Private approuterview As VRouterView		'ignore
	Private appsnack As VSnackBar				'ignore
	Private appspacer As VSpacer				'ignore
	Private apptransition As VTransition		'ignore
	Private btnLogOff As VFAB					'ignore
	Private drwlist As VList					'ignore
	Private drwoptions As VListOptions			'ignore
	Private inspire As VApp						'ignore
End Sub


#if css
::-webkit-scrollbar {
  background: transparent;
  width: 12px !important;
}
::-webkit-scrollbar-thumb {
  background: #606060 !important;
  border-radius: 100px !important;
}
#End If

Sub Init					'ignoreDeadCode
	'initialize the app
	vuetify.Initialize(Me, Main.AppName)
	'set the app title
	vuetify.SetData("apptitle", Main.AppTitle)
	'load the base layout
	BANano.LoadLayout(vuetify.Here, "baselayout")
	
	'set the list options
	drwlist.SetOptions(drwoptions)
	'
	'tell instance about the router view
	vuetify.BindRouterView(approuterview)
	'tell instace about the progress loader
	vuetify.BindProgressLoaderOn(appbar)
	
	'add other route component pages
	AddPages
		
	'add items to the drawer at runtime
	vuetify.OnCreated("oncreated", Null)
	'render the ux
	vuetify.Serve
End Sub


Sub oncreated			'ignoreDeadCode
	'clear the drawer
	drwlist.ClearOnApp(vuetify)
	drwlist.AddHeader("Enhanced Design System")
	drwlist.AddItem("", "homex", "mdi-home", "green", "Home", "/")
	drwlist.AddItem("", "onex", "mdi-access-point-check", "orange", "One", "/one")
	drwlist.AddItem("", "twox", "mdi-silverware", "brown", "Two", "/two")
	drwlist.AddItem("", "llx", "mdi-leaf", "indigo", "Leaflet", "/leaf")
	'refresh the drawer
	drwlist.RefreshOnApp(vuetify)
End Sub

'code to add other pages to the app
Sub AddPages			'IgnoreDeadCode
	pgViewHome.Initialize(vuetify) 
End Sub

Private Sub apphamburger_ClickStop (e As BANanoEvent)			'ignoreDeadCode
	appdrawer.ToggleOnApp(vuetify)
End Sub

Private Sub drwlist_Click (item As Map)				'ignoreDeadCode
	'vuetify.ShowSwal(BANano.ToJson(item))
End Sub

Private Sub btnLogOff_Click (e As BANanoEvent)			'ignoreDeadCode
	vuetify.ShowSnackBarSuccess("Log off...")
End Sub